function love.load()
	require "levels/dungeon_1" --includes the lvls(dungeons)
	require "battle/battle"
	require "json"
	require "player"
	
	font_1 = love.graphics.newFont("graphics/fonts/xirod.ttf", 10)
	font_2 = love.graphics.newFont("graphics/fonts/C64.ttf", 10)
	font_3 = love.graphics.newFont("graphics/fonts/font_3.ttf", 15)
	boss_1 = love.graphics.newImage("graphics/boss_1.png")
	background = love.graphics.newImage("graphics/Background.png")
	battle = love.graphics.newImage("battle/Background.png")
	guy_d = love.graphics.newImage("graphics/Player_D.png") --1 (Directional Graphics)
	guy_u = love.graphics.newImage("graphics/Player_U.png") --2 (Directional Graphics)
	guy_l = love.graphics.newImage("graphics/Player_L.png") --3 (Directional Graphics)
	guy_r = love.graphics.newImage("graphics/Player_R.png") --4 (Directional Graphics)
	flor= love.graphics.newImage("graphics/Floor.png") --0 (on map) (Should be floor but, whatever)
	wall= love.graphics.newImage("graphics/Wall.png") --1 (on map)
	checkpoint= love.graphics.newImage("graphics/Stairs_down.png") --2 (on map)
	decheck= love.graphics.newImage("graphics/Stairs_down.png") --3 (on map)
	chest= love.graphics.newImage("graphics/Chest.png") --4 (on map)
	monsters= love.graphics.newImage("battle/Monster_PlaceHolder.png")
	menu_bg= love.graphics.newImage("graphics/Menu_BG.png")
	
    player = { --Assigns stuff to player. 1(exept for background) is true, 0 is false
        grid_x = 256,
        grid_y = 256,
        act_x = 200,
        act_y = 200,
        speed = 10,
		direction = 1,
		health = 100,
		sword = 1,
		shield = 0,
		level=1,
		xp = 0,
		rank = 1,
		rankxp = 50,
		xpneed = 0,
		gamestate = "Menu"
    }
	player.xpneed = player.rankxp-player.xp
	
	if not love.filesystem.exists("dungeon.txt") then
		love.filesystem.newFile("dungeon.txt")
		love.filesystem.write("dungeon.txt", json.encode(player))
	end
	
	if love.filesystem.exists("dungeon.txt") then
		player = json.decode(love.filesystem.read("dungeon.txt"))
		if player.gamestate=="Play" then
			level_load()
		end
		
		if player.gamestate=="Fight" then
			battleStart(player)
		end
	end
	
	
	level_load() --Loads lvl
	monster=math.random()
	mon=0
	v=0.1
end

function love.update(dt)
	if gameIsPaused then return end --Pauses the game when not focused
	fps = love.timer.getFPS()
	
	if player.gamestate == "Play" then
		player.act_y = player.act_y - ((player.act_y - player.grid_y) * player.speed * dt) --Sets the player's x
		player.act_x = player.act_x - ((player.act_x - player.grid_x) * player.speed * dt) --Sets the player's y
	
		if player.xp > player.rankxp then
			player.rank = player.rank + 1
			player.rankxp = player.rank*50 + math.random(50)
		end
		player.xpneed = player.rankxp-player.xp
	end
	
	if player.gamestate == "Fight" then
		battleUpdate(player)
	end
end

function love.focus(f)
	gameIsPaused = not f
end

function love.draw()
	love.graphics.draw(background, 0, 0)
	love.graphics.setFont(font_2)
    love.graphics.print("This is the help for this game.\nUse the arrow keys the control\nthe player. It loads automaticaly\nwhen you start( If it doesn't\nthen press L ). You save when you\nexit the game. When in a battle\nuse 1(Attack) or 2(Heal)\nPre-Alpha v."..v.."\n\n\n\nDebugging Info:\nFPS:"..fps.."\nRandom:"..monster.."\nMonsters(True/False):"..mon.."\nHealth:"..player.health.."\nSword:"..player.sword.."\nXp:"..player.xp.."\nXp needed:"..player.xpneed.."\nRank:"..player.rank.."\nGameState:"..player.gamestate.."", 500, 30) --help
 if player.gamestate=="Play" then
   for y=1, #map do --draws the map
        for x=1, #map[y] do
            if map[y][x] == 1 then
                love.graphics.draw(wall, x * 32 , y * 32)
            end
            if map[y][x] == 2 then
                love.graphics.draw(checkpoint, x * 32 , y * 32 )
            end
            if map[y][x] == 3 then
                love.graphics.draw(decheck, x * 32 , y * 32 )
            end
            if map[y][x] == 0 then
                love.graphics.draw(flor, x * 32 , y * 32 )
            end
            if map[y][x] == 4 then
                love.graphics.draw(chest, x * 32 , y * 32 )
            end
            if map[y][x] == 5 then
                love.graphics.draw(boss_1, x * 32 , y * 32 )
            end
        end
    end
	playerDirection(player)
	end
	if player.gamestate=="Fight" then
		battleDraw ( battle, monsters )
		love.graphics.print("Enemy Health:"..enemy.health.."\nEnemy Stamina:"..enemy.stamina.."", 500, 500)
	end
	if player.gamestate=="Menu" then
		love.graphics.draw(menu_bg, 32, 32)
	end
end

function love.keypressed(key)
	if key == "escape" then
   		return love.event.push("quit") or love.event.push("q")
	end
	
	if key == "p" and player.gamestate=="Fight" then
		player.gamestate="Play"
		mon = 0
		level_load()
	end

	if key == "l" and player.gamestate=="Play" then
		player = json.decode(love.filesystem.read("dungeon.txt"))
	end
	
	if player.gamestate=="Play" then
		playerMove(key, player)
	end
	
	if player.gamestate=="Fight" then
		battleButton( key )
	end
end

function testMap(x, y) --Collisions
    if map[(player.grid_y / 32) + y][(player.grid_x / 32) + x] == 1 then
        return false
    end
	if map[(player.grid_y / 32) + y][(player.grid_x / 32) + x] == 2 then
		player.level = player.level + 1
		level_load()
		
        return true
    end
	if map[(player.grid_y / 32) + y][(player.grid_x / 32) + x] == 3 then
		player.level = player.level - 1
		level_load()
		
        return true
    end
    if map[(player.grid_y / 32) + y][(player.grid_x / 32) + x] == 4 then
    	player.xp = player.xp + math.random(10)
        return false
    end
    if map[(player.grid_y / 32) + y][(player.grid_x / 32) + x] == 5 then
    	player.health = player.health - 5 --for testing purposes
    	player.xp = player.xp + math.random(20)
        return false
    end
    return true
end

function love.mousepressed( x, y, button )
	if player.gamestate == "Menu" and x > 180+32 and x < 180 + 90 + 32 and y > 240+32 and y < 240 + 40 + 32 then
       player.gamestate = "Play"
	end
	
	if player.gamestate == "Menu" and x > 180+32 and x < 180 + 90 + 32 and y > 280+32 and y < 280 + 40 + 32 then
       return love.event.push("quit") or love.event.push("q")
	end
end

function love.quit()
  --Before quitting, save the new information to the savefile.
	love.filesystem.write("dungeon.txt", json.encode(player))
end